//
//  GLSymbolizer.h
//  GLMapKit
//
//  Created by Jeffrey Early on 1/1/07.
//  Copyright 2007 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import <GLGeometryKit/GLDrawContext.h>
#import <GLGeometryKit/GLSpatialObject.h>

extern NSString *GLDrawPropertyKey;

typedef enum {
	kGLPointSymbolizerType,
    kGLLineSymbolizerType,
    kGLPolygonSymbolizerType,
    kGLTextSymbolizerType

} GLSymbolizerType;

@class GLSpatialObject;
@interface GLSymbolizer : NSObject <NSCopying> {

}

+ (NSArray *) drawPropertyKeyPaths;

@property(readonly) GLSymbolizerType symbolizerType;
- (BOOL) isEqualToSymbolizer: (GLSymbolizer *) aSymbolizer;

/************************************************/
/*		Spatial Object Draw Additions			*/
/************************************************/

#pragma mark -
#pragma mark Spatial Object Draw Additions
#pragma mark

// If drawContext and spatialObject are nil, then the symbolizer was removed from all possible contexts and will be destroyed.
- (void) didRemoveFromContext: (NSObject <GLDrawContext> *) drawContext forSpatialObject: (id <GLSpatialObject>) spatialObject;

// Sorts through its rules and symbolizes the spatial object in the context.
- (void) drawSpatialObject: (id <GLSpatialObject>) spatialObject inContext: (NSObject <GLDrawContext> *) drawContext selected: (BOOL) isSelected;

- (BOOL) isSpatialObject: (id <GLSpatialObject>) spatialObject atPoint: (GLPoint) aPoint inContext: (NSObject <GLDrawContext> *) drawContext selected: (BOOL) isSelected;

@end
