//
//  GLMapDataSourceController.h
//  GLMapKit
//
//  Created by Jeffrey Early on 9/25/07.
//  Copyright 2007 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>

@class GLMapDataSource;
@interface GLMapDataSourceController : NSObject {
	NSMutableArray *mapDataSourceArray;
	NSPersistentStoreCoordinator *persistentStoreCoordinator;
    NSManagedObjectModel *managedObjectModel;
    NSManagedObjectContext *managedObjectContext;
}

/************************************************/
/*		Initialization							*/
/************************************************/

#pragma mark -
#pragma mark Initialization
#pragma mark

+ (id) sharedMapDataSourceController;

/************************************************/
/*		Accessors								*/
/************************************************/

#pragma mark -
#pragma mark Accessors
#pragma mark

@property(readwrite, strong) NSMutableArray *mapDataSourceArray;

- (void) addMapDataSource: (GLMapDataSource *) datasource;

// These methods are called by the respective data sources when they finish downloading a tile. The controller saves
// the tiles location on the local hard drive to its sql database. The data source can then ask for its local cache at
// any time.
- (void) cachePath: (NSString *) path withUID: (NSString *) UID forDataSource: (GLMapDataSource *) dataSource;
- (NSMutableDictionary *) tileCacheDictionaryForDataSource: (GLMapDataSource *) dataSource;

/************************************************/
/*		CoreData								*/
/************************************************/

#pragma mark -
#pragma mark CoreData
#pragma mark

@property(readonly) NSPersistentStoreCoordinator *persistentStoreCoordinator;
@property(readonly) NSManagedObjectModel *managedObjectModel;
@property(readonly) NSManagedObjectContext *managedObjectContext;

@end
